# meds/bots/__init__.py
#
#

""" bots unit. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import get_name, short_date, get_type
from meds.defines import BLA, ENDC
from meds.scheduler import Dispatcher
from meds.runtime import kernel, fleet
from meds import Thing

from meds.errors import RemoteDisconnect

import logging
import socket
import time

## BOTS

class Bot(Dispatcher):

    """ Basic Bot. """

    def __init__(zelf, *args, **kwargs):
        Dispatcher.__init__(zelf, *args, **kwargs)
        zelf._start = time.time()
        zelf.channels = ["#meds", ]

    def say(zelf, *args, **kwargs): print(args[1])
        
    ## CHANNELS

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        zelf._last = time.time()
        logging.info("# announce %s" % " ".join(zelf.channels))
        for channel in zelf.channels: zelf.say(channel, args[0])

    def join(zelf, *args, **kwargs): pass
        
    def join_channels(zelf, *args, **kwargs):
        """ join channels.  """ 
        for channel in zelf.channels: zelf.join(channel)
            
## TESTBOT

class TestBot(Bot):

    """ USE WITH Bot.put() and Bot.read(). """

    testing = True

    def say(zelf, *args, **kwargs): logging.warn(args[1])

    def event(zelf, *args, **kwargs):
        o = Thing()
        o.origin = "test@meds"
        o._target = zelf
        o.loglevel = "warning"
        return o

## CMNDS

def bot_join(event):
    if not event.args: return
    channel = event.args[0]
    for bot in fleet:
        if "join" not in bot: continue
        bot.join(channel)
        event.reply("join %s (%s)" % (channel, bot.server))

kernel.register("bot.join", bot_join)

def bot_part(event):
    if not event.args: return
    for bot in fleet:
        if "part" not in bot: continue
        bot.part(event.args[0])
        event.reply("part %s (%s)" % (channel, bot.server))

kernel.register("bot.part", bot_part)

def bot_nick(event):
    if not event.args: return
    for bot in fleet:
        if "nick" not in bot: continue
        bot.nick(event.args[0])
        event.reply("nick %s" % bot.server)

kernel.register("bot.nick", bot_nick)

def bot_quit(event):
    if not event.args: return
    for bot in fleet:
        if "quit" not in bot: continue
        bot.quit(event.rest())
        event.reply("quit %s" % bot.server)
    
kernel.register("bot.quit", bot_quit)
