# meds/bots/cli.py
#
#

""" console programma voor de enkele gebruiker. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.defines import BLA, GREEN, ENDC
from meds.runtime import fleet, rules
from meds.helpers import short_date
from meds.bots import Bot
from meds.errors import RemoteDisconnect
from meds import Thing

import time
import sys


## CLI

class CLI(Bot):

    """ bot running on the console. """

    cc = ""

    def _raw(zelf, *args, **kwargs): sys.stdout.write(args[0] + "\n") ; sys.stdout.flush()

    def say(zelf, *args, **kwargs): zelf._raw(args[1])

    def prompt(zelf, *args, **kwargs):
        zelf.wait()
        return "%s %s<%s " % (short_date(time.ctime(time.time())).split()[1], GREEN, ENDC)

    def event(zelf, *args, **kwargs):
        event = Thing()
        event._target = zelf
        event.origin = "root@shell"
        event.cc = zelf.cc
        zelf.ready()
        event.txt = input(zelf.prompt())
        return event

    def start(zelf, *args, **kwargs):
        fleet.append(zelf)
        if not rules.shell:
            thrs = zelf.single(" ".join(rules.runargs))
            if thrs: zelf.collect(thrs)
            zelf.ready()
            return
        Bot.start(zelf)
