# meds/clock.py
#
#

""" op de klok geschakeld. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import error, get_named
from meds.runtime import kernel, fleet
from meds import Thing

import threading
import logging
import time

# TIMER

class Timer(Thing):

    def __init__(zelf, time_alarm, event, *args, **kwargs):
        Thing.__init__(zelf, *args, **kwargs)
        zelf.sleep = time_alarm - time.time()
        zelf._start = time.time()
        zelf._status = "start"
        zelf._last = time.time()
        zelf._event = event

    def start(zelf, *args, **kwargs):
        zelf._status = "running"
        if zelf.sleep > 0: time.sleep(zelf.sleep)        
        zelf.echo()

    def echo(zelf, *args, **kwargs):
        for bot in fleet: bot.announce(zelf._event.rest())
        
## LOOPS

class Repeater(Thing):

    """ a LOOPER calls a function every x seconds. """ 

    def __init__(zelf, func, sleeptime, *args, **kwargs):
        """ args = function, sleeptime. """
        Thing.__init__(zelf, *args, **kwargs)
        zelf.func = func
        zelf._start = time.time()
        zelf._last = time.time()
        zelf._status = "start"
        zelf._running = get_named(zelf.func)
        zelf.sleep = sleeptime

    def start(zelf, *args, **kwargs):
        """ initialize a Looper. """
        zelf._status = "running"
        while zelf._status:
            zelf._last = time.time()
            try: zelf.func()
            except: error()
            if zelf.sleep > 0: time.sleep(zelf.sleep)

    def exit(zelf, *args, **kwargs): zelf._status = ""
