# meds/defines.py
#
#

""" defines. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

import string
import socket
import os.path
import os
import re

## RUNTIME

homedir = os.path.expanduser("~") 
curdir = os.getcwd()
try: hostname = socket.getfqdn()
except: hostname = "localhost" 
port = 10102

## CONSTANTS

leapfactor = float(6*60*60)/float(365*24*60*60)

daylist = ["Date", "path"]

# Sat, 13 Oct 2012 11:18:45 -0700 (PDT)

dayformats = ["%Y-%m-%d %H:%M:%S", "%a, %d %m %Y %H:%M:%S", "%a, %d %m %Y %H:%M:%S %s (%s)", "%Y-%m-%d %H:%M:%S", "%Y-%m-%d", "%d-%m-%Y"]
dayshorts =  ["%H:%M:%S", "%H:%M"]
short_day = "(%s %s %s %s:%s:%s)"

basic_types= [ str, int, float, bool, None]

attributes = {}
subelements = {}

attributes['message'] = ['type', 'from', 'to', 'id']
subelements['message'] = ['subject', 'body', 'error', 'thread', 'x']

attributes['presence'] = ['type', 'from', 'to', 'id']
subelements['presence'] = ['show', 'status', 'priority', 'x']


attributes['iq'] = ['type', 'from', 'to', 'id']
subelements['iq'] = ['query', 'error']

## DEFINITIONS

timere = re.compile('(\S+)\s+(\S+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+(\d+)')
bdmonths = ['Bo', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
monthint = {
            'Jan': 1,
            'Feb': 2,
            'Mar': 3,
            'Apr': 4,
            'May': 5,
            'Jun': 6,
            'Jul': 7,
            'Aug': 8,
            'Sep': 9,
            'Oct': 10,
            'Nov': 11,
            'Dec': 12
           }

dirmask = 0o700
filemask = 0o600
allowedchars = string.ascii_letters + string.digits + "_,-. \n" + string.punctuation
allowednamechars = string.ascii_letters + string.digits + '!.@'

## OPTIONS

opts_defs = [
              ('', '--debug', 'store_true', False, 'debug',  "enable debug mode"),
              ('-b', '--background', 'store_true', False, 'background',  "switch to background mode"),
              ('-o', '--openfire', 'store_true', False, 'openfire', 'use openfire to connect to XMPP.'),
              ('-s', '--shell', 'store_true', False, 'shell',  "shell mode."),
              ('-i', '--init', 'string', "", 'init',  "whether to initialize plugins."),
              ('-d', '--workdir', 'string',  os.path.expanduser(homedir + os.sep + "meds.data"), 'workdir',  "directory to work with."),
              ('-p', '--port', 'string', "10102", 'port',  "port to run API server on"),
              ('-l', '--loglevel', 'string', "error", 'loglevel',  "loglevel")
          ]

opts_defs_sed = [
              ('-d', '--dir', 'string', "", 'dir_sed',  "directory to work with."),
              ('-l', '--meldinglevel', 'string', "", 'meldinglevel',  "meldinglevel"),
          ]

opts_defs_udp = [
              ('-p', '--port', 'string', "10102", 'port',  "port to run API server on"),
              ('-l', '--meldinglevel', 'string', "", 'meldinglevel',  "meldinglevel"),
          ]

## COLORS

ERASE_LINE = '\033[2K'
BOLD='\033[1m'
GRAY='\033[99m'
RED = '\033[91m'
YELLOW = '\033[93m'
GREEN = '\033[92m'
BLUE = '\033[94m'
BLA = '\033[95m'
ENDC = '\033[0m'

## URLS

re_url_match  = re.compile('((?:http|https)://\S+)')
