# meds/plugs/desk.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import to_str, elapsed_days, error
from meds.runtime import kernel, plugs, rules
from meds import __version__

import threading
import time
import meds
import os

## CMNDS

def desk_version(event): event.reply("MEDS #%s - medicine effect registration program." % __version__)

kernel.register("desk.version", desk_version)

def desk_morning(event): event.reply("good morning !!")

kernel.register("desk.mogge", desk_morning)

def desk_running(event): event.reply(", ".join([str(x) for x in threading.enumerate()]))

kernel.register("desk.running", desk_running)

def desk_usage(event):
    data = os.popen("ps -p %s -o pid,tid,class,rtprio,ni,pri,psr,rss,pcpu,stat,wchan:14,comm" % os.getpid()).read().strip()
    event.reply(str(data))

kernel.register("desk.usage", desk_usage)

def desk_keys(event):
    result = []
    for obj in kernel.things():
        for key in obj.obj():
            if key not in result: result.append(key)
    for arg in event.args:
        result = filter(lambda x: arg not in x, result)
    if result: event.reply(" ".join(result))

kernel.register("desk.keys", desk_keys)

def desk_ls(event):
    rest = event.rest()
    if not rest:
       result = set([x.split(".")[-1] for x in kernel.names()])
       event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = kernel.search(rest)
    if keys: event.reply(", ".join(keys))
 
kernel.register("desk.ls", desk_ls)

def desk_plugs(event):
    rest = event.rest()
    if not rest:
       result = set(werken.names())
       event.reply(", ".join(sorted([".".join(x.split(".")[1:]) for x in result])))
       return
    name = ""
    keys = kernel.search(rest)
    event.reply(", ".join([".".join(x.split(".")[1:]) for x in keys]))
 
kernel.register("desk.plugs", desk_plugs)

def desk_cfg(event):
    obj = rules
    if event.args:
        ctype = event.args[0]
        obj = kernel.last("rules", ctype)
        if not obj: obj = getattr(meds.rules, "rules_%s" % ctype, None)
    try: 
        key = event.args[1]
        value = event.args[2]
        if key in obj: obj[key] = value ; obj.prefix = "rules" ; obj.sync()
    except IndexError: pass
    if obj: event.reply("\n".join(obj.show()))

kernel.register("desk.cfg", desk_cfg)

def desk_kernel(event): event.reply(kernel.pretty())

kernel.register("desk.kernel", desk_kernel)

def desk_where(event):
    name = event.rest()
    cmnds = kernel.search(name)
    result = []
    for name in cmnds: result.extend([x.plugname for x in kernel.get(name)])
    if result: event.reply(", ".join(set(result)))

kernel.register("desk.where", desk_where)

## HELPERS

def until(obj): 
    try: return elapsed_days(int(obj.sleep) - int(time.time() - obj._last))
    except: error() ; return ""

def upt(obj):
    try: return elapsed_days(int(time.time()) - int(obj._start))
    except: return ""

def waiting(obj):
    if sleeptime(obj): return "%s/%s" % (until(obj), sleeptime(obj))
    else: return ""

def idle(obj):
    try: return elapsed_days(int(obj._last - obj._start))
    except: return ""

def since(obj):
    try: return elapsed_days(int(time.time()) - int(obj._last))
    except: return ""

def status(obj):
    try: return obj._status 
    except: return ""

def name(obj):
    try: return obj._name
    except: return ""

def running(obj):
    try: return obj._running
    except: return ""

def sleeptime(obj):
    try: return elapsed_days(obj.sleep)
    except: return ""

def plugname(obj):
    try: return obj.plugname
    except: return ""

funcs = [status, upt, waiting]

def desk_running(event):
    threads = [x for x in threading.enumerate() if status(x)]
    for obj in sorted(threads, key=name):
        try: o = obj.func.__self__
        except: o = obj
        res = "%s: " % name(obj)
        for func in funcs:
            a = func(o)
            if not a: continue
            try: res += "%s " % a
            except: error()
        event.reply(res)
 
kernel.register("desk.running", desk_running)

def desk_names(event):
    import meds
    rest = event.rest()
    for naam in dir(meds):
       if "_" in naam: continue
       if rest not in naam: continue
       mod = getattr(meds, naam, None)
       event.reply("%s: %s" % (naam, ", ".join([x for x in dir(mod) if not x.startswith("_")])))

kernel.register("desk.names", desk_names)
