# meds/plugs/store.py
#
#

""" storage. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import short_date
from meds.runtime import kernel
from meds import Thing

import time
import os

## CMNDS

def store_deleted(event):
    if not event.args: return
    nr = 1
    for obj in kernel.all("deleted"): event.reply(obj.format(nr)) ; event.reply("") ; nr += 1 

kernel.register("store.deleted", store_deleted)

def store_gone(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for obj in kernel.things():
       if key not in obj: continue
       if match not in obj[key]: continue
       obj.deleted = True
       obj.sync()
       nr += 1
    event.ok(nr)

kernel.register("store.gone", store_gone)

def store_back(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for obj in kernel.things(**{"full": True}):
       if key not in obj: continue
       if match not in obj[key]: continue
       if "deleted" not in obj: continue
       obj.deleted = False
       obj.sync()
       nr += 1
    event.ok(nr)

kernel.register("store.back", store_back)

def store_first(event):
    if not event.args: return
    obj = kernel.first(event.args[0])
    if obj: event.reply(obj.json())

kernel.register("store.first", store_first)

def store_last(event):
    if not event.args: return
    obj = kernel.last(event.args[0])
    if obj: event.reply(obj.json())

kernel.register("store.last", store_last)
