# meds/plugs/udp.py
#
#

""" relay txt through a udp port listener. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import error, get_name
from meds.extra import rijndael
from meds.runtime import kernel
from meds.rules import rules_udp
from meds.errors import StopIter
from meds import Thing

import logging
import socket
import queue
import meds
import time
import re

crypt = rijndael.rijndael(rules_udp.seed)

## UDP class

class UDP(Thing):

    def __init__(zelf, *args, **kwargs):
        Thing.__init__(zelf, *args, **kwargs)
        zelf._status = "start"
        zelf._start = time.time()
        zelf._sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        zelf._sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        try: zelf._sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEPORT, 1)
        except: pass
        zelf._sock.setblocking(1)

    def start(zelf):
        zelf._sock.bind((rules_udp.host, rules_udp.port))
        logging.warn("# start %s/%s" % (rules_udp.host, rules_udp.port)) 
        zelf.ready()
        zelf._status = "running"
        while zelf._status:
            input, addr = zelf._sock.recvfrom(64000)
            if not zelf._status: break
            input = str(input.rstrip(), "utf-8")
            data = ""
            for i in range(int(len(input)/16)):
                txt = input[i*16:i*16+16]
                try: data += crypt.decrypt(txt)
                except Exception as ex: error() ;  break
            if not data: break
            zelf.output(data, addr)
        
    def exit(zelf, *args, **kwargs):
        logging.warn("# exit %s" % get_name(zelf))
        zelf._status = "exit"
        zelf._sock.settimeout(1.0)
        zelf._sock.sendto(bytes("bla", "utf-8"), (rules_begrip.host, rules_begrip.port))
        #zelf._sock.shutdown(socket.SHUT_WR)

    def output(zelf, input, addr):
        passwd, text = input.split(" ", 1)
        text = text.replace("\00", "")
        if passwd == regels_begrip.password: hemel.melden(text)

def init(*args, **kwargs):
    udp = UDP()
    kernel.put(udp.start)
