# meds/runtime.py
#
#

""" Not Your Will. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.helpers import make_opts, hello, error
from meds.defines import opts_defs
from meds.scheduler import Dispatcher
from meds.log import init
from meds.plugs import Plugs
from meds.rules import rules_kernel
from meds import Thing

import logging
import sys
import os

def medspath():
    for path in sys.path:
        if "meds" in path and "egg" in path: yield path  

## Hemel

class Kernel(Plugs):

    def boot(zelf, *args, **kwargs):
        opts, arglist = make_opts(opts_defs)
        rules.update(rules_kernel)
        rules.update(vars(opts))
        rules.runargs = arglist
        rules.shell = True
        if arglist: rules.shell = False
        if rules.shell and args: hello(args[0])
        init(rules.loglevel)
        if rules.loglevel != "error":
            print("\n".join(sorted(rules.show())))
            print("path=%s" % ", ".join(list(medspath()))) 
            print("")
        for package in rules.packages:
            try: plugs.load(package)
            except: error()
        plugs.init(rules.init)
        zelf.ready()
        return zelf

    def shutdown(zelf, *args, **kwargs): logging.warn("# shutdown")

## DEFINITIES

kernel = Kernel()
plugs = Plugs()
rules = Thing()
fleet = []
